DesertPalmSpawner = Class(function(self, inst)
    self.inst = inst
    self.has_spawned = false
    self.only_spawn_offscreen = true        
    self.inst:ListenForEvent("seasonChange", OnSeasonChange)
end)

function OnSeasonChange(inst, data)
    inst.components.desertpalmspawner:OnSeasonChange(inst, data)
end

function DesertPalmSpawner:SpawnPalm()
    for i=1, math.random(10) do
        if not self.has_spawned and not GetSeasonManager():IsWinter() then
            local loc = self:FindSpawnLocation()

            if loc then
                local palm = SpawnPrefab("desertpalm")
                palm.components.growable:SetStage(1)
                if math.random() < .3 then
                    local locnew = Vector3(loc.x + math.random(3, 8), loc.y, loc.z - math.random(3, 8))
                    local tiletype = GetGroundTypeAtPosition(locnew)
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then
                        palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else
                        local locnew = Vector3(loc.x + math.random(3, 8), loc.y, loc.z - math.random(3, 8))
                        local tiletype = GetGroundTypeAtPosition(locnew)
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then
                            palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                            else palm:Remove()
                        end
                    end
                elseif math.random() > .7 then
                    local locnew = Vector3(loc.x - math.random(3, 8), loc.y, loc.z + math.random(3, 8))
                    local tiletype = GetGroundTypeAtPosition(locnew)
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then                
                        palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else
                        local locnew = Vector3(loc.x - math.random(3, 8), loc.y, loc.z + math.random(3, 8))
                        local tiletype = GetGroundTypeAtPosition(locnew)
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then                
                            palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                            else palm:Remove()
                        end
                    end
                else
                    local locnew = Vector3(loc.x - math.random(3, 8), loc.y, loc.z - math.random(3, 8))
                    local tiletype = GetGroundTypeAtPosition(locnew)
                    local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                    if ground_OK then
                        palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                    else 
                        local locnew = Vector3(loc.x - math.random(3, 8), loc.y, loc.z - math.random(3, 8))
                        local tiletype = GetGroundTypeAtPosition(locnew)
                        local ground_OK = tiletype ~= GROUND.IMPASSABLE and #TheSim:FindEntities(locnew.x, locnew.y, locnew.z, 1) <= 0
                        if ground_OK then
                            palm.Transform:SetPosition(locnew.x, locnew.y, locnew.z)
                            else palm:Remove()
                        end
                    end
                end
            end
        end
    end
    self.has_spawned = true
end

function DesertPalmSpawner:FindSpawnLocation() 
--print("Finding palm to spawn from......")   
    local allvalidpalms = {}
    for guid, ent in pairs(Ents) do
        if ent.entity:IsValid() and ent.prefab == "desertpalm" --[[and ent.components.growable.stage == 1]] and (not self.only_spawn_offscreen or ent:IsAsleep()) then
            table.insert(allvalidpalms, ent)
        end
    end    
    --print("Found "..(# allvalidpalms).." valid palm tree entities to spawn from")
    if next(allvalidpalms) == nil then
        return
    else
        local spawnpalm = GetRandomItem(allvalidpalms)
        return Vector3(spawnpalm.Transform:GetWorldPosition())
    end
end

function DesertPalmSpawner:OnSeasonChange(inst, data)
    local season = data.season
    if season == SEASONS.WINTER then
        self.has_spawned = false   
    elseif (SEASONS.SPRING ~= nil and season == SEASONS.SPRING) or (SEASONS.SPRING == nil and season == SEASONS.SUMMER) then
        self:SpawnPalm()
    end
end

function DesertPalmSpawner:OnSave()
    if self.has_spawned then
        return{has_spawned = self.has_spawned}
    end
end

function DesertPalmSpawner:OnLoad(data)
    if data then
        self.has_spawned = data.has_spawned
    end
    self:SpawnPalm()
end

return DesertPalmSpawner