local assets=
{
	Asset("ANIM", "anim/coconutmilk.zip"),
	Asset("ATLAS", "images/inventoryimages/coconutmilk.xml"),  
	Asset("IMAGE", "images/inventoryimages/coconutmilk.tex"),	
}

local function oneaten(inst, eater)	
	if eater and eater.components.temperature then
		local temp = eater.components.temperature:GetCurrent()
		eater.components.temperature:SetTemperature(temp-7)
	end	
end

local function onfinished(inst)
    --inst:RemoveComponent("inventoryitem")    
    inst:Remove()
end

local function MakeCoconutMilk()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	--local s  = 0.35
    --inst.Transform:SetScale(s,s,s)
	local anim = inst.entity:AddAnimState()
	--inst.entity:AddSoundEmitter()
	MakeInventoryPhysics(inst)
	
	anim:SetBank("coconutmilk")
	anim:SetBuild("coconutmilk")
	anim:PlayAnimation("idle")
	
	--inst:AddTag("coconutmilk")
	--inst:AddTag("tool")
	
	inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

     inst:AddComponent("edible")
    inst.components.edible.healthvalue = 0
    inst.components.edible.hungervalue = 2
    inst.components.edible.sanityvalue = -(3*TUNING.SANITY_SUPERTINY)
    inst.components.edible:SetOnEatenFn(oneaten)
    inst.components.edible.foodtype = "VEGGIE"

	--inst:AddComponent("instrument")
    --inst.components.instrument.onplayed = OnPlayed

	--[[inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.PLAY)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(5)
    inst.components.finiteuses:SetUses(5)
    inst.components.finiteuses:SetOnFinished( onfinished)
    inst.components.finiteuses:SetConsumption(ACTIONS.PLAY, 1)]]

	inst:AddComponent("perishable")
    inst.components.perishable:SetPerishTime(TUNING.PERISH_PRESERVED)
    inst.components.perishable:StartPerishing()
    inst.components.perishable.onperishreplacement = "spoiled_food"

	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")	
	inst.components.inventoryitem.imagename = "coconutmilk"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/coconutmilk.xml"
		
	return inst
end

STRINGS.NAMES.COCONUTMILK = "Iced Coconut"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COCONUTMILK = {   
    "Ahhhhh, chilly refreshment",
    "Beats eating ice",
}


return Prefab( "coconutmilk", MakeCoconutMilk, assets)